'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x2, _x3, _x4) { var _again = true; _function: while (_again) { var object = _x2, property = _x3, receiver = _x4; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x2 = parent; _x3 = property; _x4 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

exports['default'] = loading;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var Loading = (function (_Component) {
  _inherits(Loading, _Component);

  function Loading() {
    _classCallCheck(this, Loading);

    _get(Object.getPrototypeOf(Loading.prototype), 'constructor', this).apply(this, arguments);
  }

  _createClass(Loading, [{
    key: 'render',
    value: function render() {
      return _react2['default'].createElement(
        'div',
        { className: 'loading' },
        this.props.children
      );
    }
  }]);

  return Loading;
})(_react.Component);

exports.Loading = Loading;

var defaultOpts = {
  propName: 'items',
  loadingText: 'loading...'
};

/**
 * loading decorator
 *
 * @param {function} loadFunction(component)
 * @param {object} [opts={}]
 * @param {string} [opts.propName='items']
 * @param {string} [opts.loadingText='loading....']
 * @param {string} [opts.action] action to dispatch if props[propName] is false
 * @returns {Component}
 */

function loading(loadFunction) {
  var opts = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var options = Object.assign({}, defaultOpts, opts);

  return function loadingWithLoadFunction(ComposedComponent) {
    return (function (_Component2) {
      _inherits(ComponentWithLoading, _Component2);

      function ComponentWithLoading() {
        var _this = this;

        _classCallCheck(this, ComponentWithLoading);

        _get(Object.getPrototypeOf(ComponentWithLoading.prototype), 'constructor', this).apply(this, arguments);

        this.componentDidMount = function () {
          if (!_this.hasItems()) {
            var action = _this.getAction();
            action ? _this.props.dispatch(action()) : _this.getLoadFunction()(_this);
          }
        };

        this.componentWillReceiveProps = function (nextProps) {
          //if (!this.props[propName]) {
          //loadFunction(this);
          //}
        };
      }

      _createClass(ComponentWithLoading, [{
        key: 'getPropName',
        value: function getPropName() {
          return this.props.propName || options.propName;
        }
      }, {
        key: 'getLoadingText',
        value: function getLoadingText() {
          return this.props.loadingText || options.loadingText;
        }
      }, {
        key: 'hasItems',
        value: function hasItems() {
          return !!this.props[this.getPropName()];
        }
      }, {
        key: 'getAction',
        value: function getAction() {
          return this.props.action || opts.action;
        }
      }, {
        key: 'getLoadFunction',
        value: function getLoadFunction() {
          return loadFunction;
        }
      }, {
        key: 'render',
        value: function render() {
          if (!this.hasItems()) {
            return _react2['default'].createElement(
              Loading,
              null,
              this.getLoadingText()
            );
          }
          return _react2['default'].createElement(ComposedComponent, this.props);
        }
      }]);

      return ComponentWithLoading;
    })(_react.Component);
  };
}

;